#!/bin/sh

# -----------------------------------------------------------------------------
# Associate ROX 'SendTo/OpenWith' and Thunar custom action with inst-xbps
# -----------------------------------------------------------------------------
export user_home=$(eval echo ~${SUDO_USER})
Instxbps_PATH="/usr/local/bin/inst-xbps"

#LOC1="/etc/xdg/rox.sourceforge.net/SendTo"
LOC2="$user_home/.config/rox.sourceforge.net/SendTo"
LOC3="$user_home/.config/rox.sourceforge.net/OpenWith"
LOC4="/root/.config/rox.sourceforge.net/OpenWith"
mkdir -p "$LOC2" "$LOC3" "$LOC4"

if [ "$(pwd)" = "/" ]; then
	for i in "$LOC2" "$LOC3" "$LOC4"; do
		[ -d "$i" ] && { RC_PATH="$i"; break; }
	done
	DOTdesktop_PATH="/usr/share/applications/inst-xbps.desktop"
else	# Woof/Fatdog build system
	for i in ".$LOC2" ".$LOC3" ".$LOC4"; do
		[ -d "$i" ] && { RC_PATH="$i"; break; }
	done
	DOTdesktop_PATH="./usr/share/applications/inst-xbps.desktop"
fi


# Mime-Types are kept inside .desktop file
if [ -d "$RC_PATH" ]; then
	for i in $(grep '^MimeType=' "$DOTdesktop_PATH" | cut -f2- -d '=' | tr ';' '\n' | tr '/' '_' | head -n -1); do
		[ ! -d "${RC_PATH}/.${i}" ] && mkdir "${RC_PATH}/.${i}" 
		[ ! -L "${RC_PATH}/.${i}/inst-xbps" ] && ln -s "$Instxbps_PATH" "${RC_PATH}/.${i}/inst-xbps"
	done

	[ ! -L "${RC_PATH}/inst-xbps" ] && ln -s "$Instxbps_PATH" "${RC_PATH}/inst-xbps"

	[ ! -d "${RC_PATH}/.group" ] && mkdir "${RC_PATH}/.group"
	[ ! -L "${RC_PATH}/.group/inst-xbps" ] && ln -s "$Instxbps_PATH" "${RC_PATH}/.group/inst-xbps"
fi

# -----------------------------------------------------------------------------
echo $PWD
# Associate custom action with Thunar
if [ "$(pwd)" = "/" ]; then
	if [ "$(which thunar 2>/dev/null)" ] || [ "$(which Thunar 2>/dev/null)" ]; then
		CONFIG="$user_home/.config/Thunar/uca.xml"
		CONFIG_BAK="$user_home/.config/Thunar/uca.xml.bak"
		CONFIG_TMP="/tmp/uca.xml"
		EXTENSIONS="*.xbps"
		if [ -f "$CONFIG" ]; then
			grep '<name>Install xbps package</name>' "$CONFIG" >/dev/null || {
			grep -v '^</actions>' "$CONFIG" > "$CONFIG_TMP"
			echo '<action>
	<icon>xbpstools</icon>
	<name>Install xbps package</name>
	<command>/usr/local/bin/inst-xbps %f</command>
	<description>Install xbps package</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
</action>
</actions>' >> "$CONFIG_TMP"
			mv "$CONFIG" "$CONFIG_BAK"
			mv "$CONFIG_TMP" "$CONFIG"
		}
		else
			mkdir -p "${CONFIG%/*}"
			echo '<?xml encoding="UTF-8" version="1.0"?>
<actions>
<action>
	<icon>xbpstools</icon>
	<name>Install xbps package</name>
	<command>/usr/local/bin/inst-xbps %f</command>
	<description>Install xbps package</description>
	<patterns>'${EXTENSIONS}'</patterns>
	<other-files/>
</action>
</actions>' > "$CONFIG" 
		fi
	fi
fi
